package com.zhgd.xmgl.modules.basicdata.controller.admin;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zhgd.jeecg.common.api.vo.Result;
import com.zhgd.jeecg.common.system.query.QueryGenerator;
import com.zhgd.jeecg.common.util.oConvertUtils;
import com.zhgd.xmgl.modules.basicdata.entity.HardWareAlarm;
import com.zhgd.xmgl.modules.basicdata.service.IHardWareAlarmService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;


 /**
 * @Title: Controller
 * @Description: 设备报警信息表
 * @author： pds
 * @date：   2023-02-20
 * @version： V1.0
 */
@RestController
@RequestMapping("/xmgl/api")
@Slf4j
@Api(tags = "设备报警管理")
public class HardWareAlarmController {
	@Autowired
	private IHardWareAlarmService hardWareAlarmService;
	
	/**
	  * 分页列表查询
	 * @param hardWareAlarm
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@ApiOperation(value = " 分页列表查询设备报警信息", notes = "分页列表查询设备报警信息", httpMethod="GET")
	@GetMapping(value = "/list")
	public Result<IPage<HardWareAlarm>> queryPageList(HardWareAlarm hardWareAlarm,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<HardWareAlarm>> result = new Result<IPage<HardWareAlarm>>();
		QueryWrapper<HardWareAlarm> queryWrapper = QueryGenerator.initQueryWrapper(hardWareAlarm, req.getParameterMap());
		Page<HardWareAlarm> page = new Page<HardWareAlarm>(pageNo, pageSize);
		IPage<HardWareAlarm> pageList = hardWareAlarmService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param hardWareAlarm
	 * @return
	 */
	@ApiOperation(value = " 添加设备报警信息", notes = "添加设备报警信息" , httpMethod="POST")
	@PostMapping(value = "/add")
	public Result<HardWareAlarm> add(@RequestBody HardWareAlarm hardWareAlarm) {
		Result<HardWareAlarm> result = new Result<HardWareAlarm>();
		try {
			hardWareAlarmService.save(hardWareAlarm);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param hardWareAlarm
	 * @return
	 */
	@ApiOperation(value = "编辑设备报警信息", notes = "编辑设备报警信息" , httpMethod="PUT")
	@PutMapping(value = "/edit")
	public Result<HardWareAlarm> edit(@RequestBody HardWareAlarm hardWareAlarm) {
		Result<HardWareAlarm> result = new Result<HardWareAlarm>();
		HardWareAlarm hardWareAlarmEntity = hardWareAlarmService.getById(hardWareAlarm.getId());
		if(hardWareAlarmEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = hardWareAlarmService.updateById(hardWareAlarm);
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	 @ApiOperation(value = "删除设备报警信息", notes = "删除设备报警信息" , httpMethod="DELETE")
	 @ApiImplicitParam(name = "id", value = "设备报警信息表ID", paramType = "query", required = true, dataType = "Integer")
	@DeleteMapping(value = "/delete")
	public Result<HardWareAlarm> delete(@RequestParam(name="id",required=true) String id) {
		Result<HardWareAlarm> result = new Result<HardWareAlarm>();
		HardWareAlarm hardWareAlarm = hardWareAlarmService.getById(id);
		if(hardWareAlarm==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = hardWareAlarmService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	 @ApiOperation(value = "批量删除设备报警信息", notes = "批量删除设备报警信息",  httpMethod="DELETE")
    @ApiImplicitParam(name = "id", value = "设备报警信息表ID字符串", paramType = "query", required = true, dataType = "String")
	@DeleteMapping(value = "/deleteBatch")
	public Result<HardWareAlarm> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<HardWareAlarm> result = new Result<HardWareAlarm>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.hardWareAlarmService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	 @ApiOperation(value = "通过id查询设备报警信息", notes = "通过id查询设备报警信息" , httpMethod="GET")
     @ApiImplicitParam(name = "id", value = "设备报警信息表ID", paramType = "query", required = true, dataType = "Integer")
	@GetMapping(value = "/queryById")
	public Result<HardWareAlarm> queryById(@RequestParam(name="id",required=true) String id) {
		Result<HardWareAlarm> result = new Result<HardWareAlarm>();
		HardWareAlarm hardWareAlarm = hardWareAlarmService.getById(id);
		if(hardWareAlarm==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(hardWareAlarm);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @ApiOperation(value = "导出excel设备报警信息", notes = "导出excel设备报警信息" , httpMethod="POST")
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<HardWareAlarm> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              HardWareAlarm hardWareAlarm = JSON.parseObject(deString, HardWareAlarm.class);
              queryWrapper = QueryGenerator.initQueryWrapper(hardWareAlarm, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<HardWareAlarm> pageList = hardWareAlarmService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "设备报警信息表列表");
      mv.addObject(NormalExcelConstants.CLASS, HardWareAlarm.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("设备报警信息表列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
   @ApiOperation(value = "通过excel导入设备报警信息", notes = "通过excel导入设备报警信息", httpMethod="POST")
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<HardWareAlarm> listHardWareAlarms = ExcelImportUtil.importExcel(file.getInputStream(), HardWareAlarm.class, params);
              for (HardWareAlarm hardWareAlarmExcel : listHardWareAlarms) {
                  hardWareAlarmService.save(hardWareAlarmExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listHardWareAlarms.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

}
